#pragma once

#include "flexpage.h"
#include "memory.h"
#include "page_owner.h"
#include "page_queue.h"



/* A page collection. */

class Pages
{
protected:
    Memory *_memory;
    PageQueue *_queue;

public:
    explicit Pages(Memory *memory, PageQueue *queue);

    explicit Pages(PageQueue *queue);

    virtual ~Pages()
    {
    }

    virtual Flexpage *remove();

    virtual bool reserve(PageOwner *owner, Flexpage *flexpage);

    virtual Flexpage *flexpage();

    virtual void queue(PageOwner *owner, Flexpage *flexpage);

    virtual void release(Flexpage *flexpage);
};

// vim: tabstop=4 expandtab shiftwidth=4
